/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: ProgressiveProductionSystem.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_PROGRESSIVE_PRODUCTION_SYSTEM_HPP_
#define _TOPS_PROGRESSIVE_PRODUCTION_SYSTEM_HPP_

#include "tops/ProductionSystem.hpp"
#include "tops/PSListener.hpp"

#include "tops/system/progressive/ProgressiveRuleBase.hpp"

#include "tops/utilities/CloseContainer.hpp"

#include <map>

#include <boost/shared_ptr.hpp>

namespace tops {

	class ProgressiveProductionSystem;
	typedef boost::shared_ptr<ProgressiveProductionSystem> ProgressiveProductionSystemPtr;

	/**
	 * 進行性プロダクションシステムです。
	 *
	 * @author トゥイー
	 */
	class ProgressiveProductionSystem : public ProductionSystem, public PSListener {
	private:
		ProgressiveRuleBase m_progressiveRuleBase;

		typedef std::multimap<std::string, ProgressiveRulePtr> ProgressiveRuleMap;
		ProgressiveRuleMap m_misfireRules;

	public:
		/**
		 * 進行性プロダクションシステムを構築します。
		 */
		ProgressiveProductionSystem();

	public:
		/**
		 * 進行性ルールベースを取得します。
		 */
		const ProgressiveRuleBase& getProgressiveRuleBase() const {
			return m_progressiveRuleBase;
		}

	private:
		/**
		 * 指定したワーキングメモリ要素を進行性ルールベースと単一化させます。
		 */
		void unificateToRuleBase(WMElement& element);

		/**
		 * 指定した進行性プロダクションルールをワーキングメモリと単一化させます。
		 */
		void unificateToWorkingMemory(const ProgressiveRulePtr& rule);

	public:
		/**
		 * ワーキングメモリ要素が追加されたときに呼び出されます。
		 */
		void added(ProductionSystem& system, WMElement& element);

		/**
		 * プロダクションルールが追加されたときに呼び出されます。
		 */
		void added(ProductionSystem& system, ProductionRule& productionRule);

		/**
		 * 属性が追加されたときに呼び出されます。
		 */
		void added(ProductionSystem& system,
		           WMElement& element, const std::string& name, const ConstantPtr& constant);

	public:
		/**
		 * 進行性プロダクションルールを構築します。
		 */
		ProgressiveRulePtr createProgressiveRule(ProductionRule& rule);

		/**
		 * 進行性プロダクションルールを構築します。
		 */
		ProgressiveRulePtr createProgressiveRule(
				ProgressiveRule& parent,
				const UnificatedElementPtr& lastElement,
				const Variables& variables);

	private:
		/**
		 * 進行性プロダクションルールを追加します。
		 *
		 * @param rule 追加する進行性プロダクションルールを指定します。
		 */
		bool addProgressiveRule(const ProgressiveRulePtr& rule);

	public:
		void update();
	};

}  // namespace tops

#endif
